﻿Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win

Public Class Form1

    Dim ret As Infragistics.Win.UltraWinGrid.UltraGridRowEditTemplate
    Dim gridBag As Infragistics.Win.Misc.UltraGridBagLayoutManager
    Dim cancel As Infragistics.Win.Misc.UltraButton
    Dim accept As Infragistics.Win.Misc.UltraButton
    Dim currentBand As UltraGridBand
    Dim element As UIElement


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim data As DataTable = New DataTable
        data.Columns.Add("id", GetType(Integer)).AutoIncrement = True
        data.Columns.Add("Group1", GetType(String))
        data.Columns.Add("Group2", GetType(String))
        data.Columns.Add("String column 1", GetType(String))
        data.Columns.Add("String column 2", GetType(String))
        data.Columns.Add("String column 3", GetType(String))
        data.Columns.Add("String column 4", GetType(String))
        data.Columns.Add("String column 5", GetType(String))

        For index = 1 To 500
            data.Rows.Add(Nothing, String.Format("Group Value {0}", index Mod 10), String.Format("Group Value {0}", index Mod 7), String.Format("Test String {0}", index Mod 3), "test", "Test", "tEsts")
        Next
        data.AcceptChanges()
        UltraGrid1.DataSource = data


    End Sub

    Private Sub UltraGrid1_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        e.Layout.Bands(0).SortedColumns.Add("Group1", True, True)
        e.Layout.Bands(0).SortedColumns.Add("Group2", True, True)

        e.Layout.Bands(0).Override.AllowAddNew = AllowAddNew.Yes
        'e.Layout.Bands(0).RowEditTemplate = UltraGridRowEditTemplate1
    End Sub

    Private Sub InitRowEditTemplate(ByRef band As UltraGridBand)
        If (Me.Controls.ContainsKey("RowEdit")) Then
            ret = Me.Controls("RowEdit")
            RemoveHandler cancel.Click, AddressOf cancel_Click
            RemoveHandler accept.Click, AddressOf accept_Click
            ret.Controls.Clear()
        Else
            ret = New UltraGridRowEditTemplate()
            ret.Name = "RowEdit"
            ret.Visible = False
            ret.AutoScroll = True
            ret.Size = New System.Drawing.Size(500, 193)
            Me.Controls.Add(ret)
            gridBag = New Infragistics.Win.Misc.UltraGridBagLayoutManager()
            gridBag.ContainerControl = ret
            'These two properties will space the controls out
            'evenly in the available space.
            gridBag.ExpandToFitHeight = True
            gridBag.ExpandToFitWidth = True

           

        End If


        Dim labelTexts = New Dictionary(Of String, Boolean)

        For Each col As UltraGridColumn In band.Columns
            If Not col.HiddenResolved Then
                labelTexts.Add(col.Key, col.IsGroupByColumn)
            End If
        Next

        Dim enumeraion = labelTexts.Keys.GetEnumerator()
        enumeraion.MoveNext()
        Dim currentKey = enumeraion.Current
        Dim gridBagRow As Integer = 0
        While currentKey IsNot Nothing

            For gridBagCol = 0 To 3 Step 2
                'create the labels and add them to the 
                Dim label As New Infragistics.Win.Misc.UltraLabel()
                ret.Controls.Add(label)
                label.Text = band.Columns(currentKey).Header.Caption
                gridBag.SetGridBagConstraint(label, New Infragistics.Win.Layout.GridBagConstraint(gridBagCol, gridBagRow, 1, 1))

                'Instantiate a new UltraGridCellProxy object.
                Dim proxy As Infragistics.Win.UltraWinGrid.UltraGridCellProxy = New Infragistics.Win.UltraWinGrid.UltraGridCellProxy()
                'Set the proxy to show data from the ContactName column.
                proxy.ColumnKey = currentKey
                proxy.Size = New Size(100, 20)
                proxy.Enabled = Not labelTexts(currentKey)
                'Add the proxy to the template's Controls collection.
                ret.Controls.Add(proxy)
                'Place the proxy in row 1, column 2 of the grid bag layout.
                gridBag.SetGridBagConstraint(proxy, New Infragistics.Win.Layout.GridBagConstraint(gridBagCol + 1, gridBagRow, 1, 1))
                enumeraion.MoveNext()
                currentKey = enumeraion.Current
            Next
            gridBagRow += 1
        End While

        'Instatiate a new UltraButton object.
        cancel = New Infragistics.Win.Misc.UltraButton()
        'Set the button's text.
        cancel.Text = "Cancel"
        'Add the button to the template's Controls collection.
        ret.Controls.Add(cancel)
        'Create a handler for the cancel button.
        AddHandler cancel.Click, AddressOf cancel_Click

        'Instatiate a new UltraButton object.
        accept = New Infragistics.Win.Misc.UltraButton()
        'Set the button's text.
        accept.Text = "OK"
        'Add the button to the template's Controls collection.
        ret.Controls.Add(accept)
        'Create a handler for the accept button.
        AddHandler accept.Click, AddressOf accept_Click

        'Place the button in row 3, column 1 of the grid bag's layout.
        gridBag.SetGridBagConstraint(accept, New Infragistics.Win.Layout.GridBagConstraint(2, gridBagRow, 1, 1))


        'Place the button in row 3, column 2 of the grid bag's layout.
        gridBag.SetGridBagConstraint(cancel, New Infragistics.Win.Layout.GridBagConstraint(3, gridBagRow, 1, 1))

        band.RowEditTemplate = ret

    End Sub

    Sub accept_Click(sender As Object, e As EventArgs)
        DirectCast(UltraGrid1.DataSource, DataTable).AcceptChanges()
        'Close the template and save any pending changes.
        ret.Close(True)
    End Sub 'accept_Click

    Sub cancel_Click(sender As Object, e As EventArgs)
        DirectCast(UltraGrid1.DataSource, DataTable).RejectChanges()
        'Close the template and discard any pending changes.
        ret.Close(False)
    End Sub 'cancel_Click

    Private Sub AddNewToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AddNewToolStripMenuItem.Click
        If element IsNot Nothing Then
            Dim row As RowUIElement = element.GetAncestor(GetType(RowUIElement))
            Dim grupByRow As GroupByRowUIElement = element.GetAncestor(GetType(GroupByRowUIElement))
            If row IsNot Nothing Then
                currentBand = row.Row.Band
                Dim table = DirectCast(currentBand.Layout.Grid.DataSource, DataTable)
                Dim newRow = table.NewRow()
                If Not PopulateRowData(newRow, row.Row) Then
                    table.RejectChanges()
                    Return
                End If
                table.Rows.Add(newRow)
                FindAndPutInEditMode(newRow, row.Row.ParentCollection, "id")
                InitRowEditTemplate(currentBand)
            End If

            If grupByRow IsNot Nothing Then
                currentBand = grupByRow.GroupByRow.Band
                Dim table = DirectCast(currentBand.Layout.Grid.DataSource, DataTable)
                Dim newRow = table.NewRow()
                If Not PopulateRowData(newRow, grupByRow.GroupByRow) Then
                    table.RejectChanges()
                    Return
                End If
                table.Rows.Add(newRow)
                grupByRow.GroupByRow.ExpandAll()
                For Each childBand As UltraGridChildBand In grupByRow.GroupByRow.ChildBands
                    FindAndPutInEditMode(newRow, childBand.Rows, "id")
                Next

                InitRowEditTemplate(currentBand)
            End If

            For Each cell As UltraGridCell In UltraGrid1.ActiveRow.Cells
                If Not UltraGrid1.ActiveRow.Band.SortedColumns.Contains(cell.Column) Then
                    cell.Activate()
                    Exit For
                End If
            Next
            UltraGrid1.PerformAction(UltraGridAction.EnterEditMode)
        End If
    End Sub

    Private Sub UltraGrid1_MouseClick(sender As Object, e As MouseEventArgs) Handles UltraGrid1.MouseClick
        element = Nothing

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Dim grid = DirectCast(sender, UltraGrid)
            element = grid.DisplayLayout.UIElement.ElementFromPoint(e.Location)
            ContextMenuStrip1.Show(grid.PointToScreen(e.Location))
        End If
    End Sub

    Private Function PopulateRowData(ByRef newRow As DataRow, row As Object) As Boolean
        If TypeOf row Is UltraGridGroupByRow Then
            Dim groupByRow = DirectCast(row, UltraGridGroupByRow)
            newRow(groupByRow.Column.Key) = groupByRow.Value
            PopulateRowData(newRow, groupByRow.ParentRow)
            Return PoopulteGroups(newRow, groupByRow)
        ElseIf TypeOf row Is UltraGridRow Then
            Dim gridRow = DirectCast(row, UltraGridRow)
            PopulateRowData(newRow, gridRow.ParentRow)
        End If

        Return True
    End Function

    Private Function FindAndPutInEditMode(newRow As DataRow, rowsCollection As RowsCollection, keyCoolumn As String) As Boolean
        For Each row As UltraGridRow In rowsCollection
            If TypeOf row Is UltraGridGroupByRow Then
                Dim groupByRow = DirectCast(row, UltraGridGroupByRow)
                For Each childBand As UltraGridChildBand In groupByRow.ChildBands
                    If FindAndPutInEditMode(newRow, childBand.Rows, keyCoolumn) Then
                        Return True
                    End If
                Next

            ElseIf TypeOf row Is UltraGridRow Then
                If row.Cells(keyCoolumn).Value = newRow(keyCoolumn) Then
                    row.Activate()

                    Return True
                End If
            End If
        Next
        Return False
    End Function

    Private Function PoopulteGroups(newRow As DataRow, groupByRow As UltraGridGroupByRow) As Boolean

        For Each col As UltraGridColumn In groupByRow.Band.SortedColumns
            If newRow(col.Key).Equals(DBNull.Value) Then
                Dim frm As Form2 = New Form2
                frm.Text = String.Format("Enter Value For {0}", col.Header.Caption)
                If frm.ShowDialog() = Windows.Forms.DialogResult.Cancel Then
                    MessageBox.Show("Cannot Add row")
                    Return False
                End If
                newRow(col.Key) = frm.Key
            End If
        Next
        Return True

    End Function


End Class
